<template>
  <div class="order-trip-tabs">
    <transition name="fadeIn">
      <div
        v-if="currentTrips && currentTrips.length"
        class="multi-nav-panel"
      >
        <div
          class="nav-item"
          :class="!selectedTrip && 'active'"
          @click="onSelectedTrip(null)"
        >
          Общее
        </div>
        <!--      <ObSelect-->
        <!--        v-model="selectVal"-->
        <!--        :items="dataSelect"-->
        <!--        @input="selected"-->
        <!--        class="nav-item"-->
        <!--      />-->

        <div
          class="nav-tabs"
        >
          <TabComponent
            v-for="item in currentTrips"
            :key="item.uuid"
            :data-source="item"
            :class="selectedTrip && selectedTrip.uuid === item.uuid && 'active'"
            @click.native="onSelectedTrip(item)"
          />
        </div>
      </div>
    </transition>
  </div>
</template>

<script>
  import { mapGetters, mapActions } from 'vuex'
  import TabComponent from './TabComponent.vue'
  // import ObSelect from 'common-components/src/obComponents/obSelect/index'

  export default {
    name: 'OrderTripTabs',
    components: {
      // ObSelect,
      TabComponent
    },
    props: {
      uuid: {
        type: String,
        required: true
      }
    },
    data() {
      return {
        selectVal: null
      }
    },
    computed: {
      ...mapGetters({
        trips: 'order/orderTrips',
        order: 'order/order',
        subOrder: 'order/subOrder',
        subOrders: 'order/subOrders',
        selectedTrip: 'order/selectedTrip',
      }),
      orderId () {
        return this.$route.params.id
      },
      currentTrips () {
        let result = []

        if (this.order.uuid === this.uuid) {
          result = [...this.trips].sort((a, b) => {
            return a.tripUuid - b.tripUuid
          })
        } else {
          result = this.trips.filter((item) => {
            return item.uuid === this.uuid
          })
        }

        return result.filter((item) => item.mainType !== 'logchainOrderService').map((item) => {
          const subOrder = this.subOrders.find(order => order.uuid === item.uuid)
          return {
            ...item,
            status: item.status || (subOrder && subOrder.status) || 'NEW'
          }
        })
      }
    },
    methods: {
      ...mapActions({
        selectTrip: 'order/selectTrip'
      }),
      selected () {
        console.log(this.selectVal)
      },
      onSelectedTrip (data) {
        this.$router.replace({ query: { ...this.$route.query, trip: data ? data.uuid : undefined, tab: undefined } })
        this.$nextTick(() => {
          this.selectTrip({ data, isGetSuborder: true })
        })
      }
    }
  }
</script>

<style lang="scss" scoped>
  @import "~common-components/src/static/css/mixins";
  @import "~common-components/src/static/css/variables";

  .mt20 {
    margin-top: 20px;
  }
  .mt40 {
    margin-top: 40px;
  }
  .mb20 {
    margin-bottom: 20px;
  }
  .mt10 {
    margin-top: 10px;
  }
  .mr10 {
    margin-right: 10px;
  }
  .fadeIn-enter, .fadeIn-leave-to {
    opacity: 0;
  }
  .fadeIn-enter-active, .fadeIn-leave-active {
    transition: all .2s ease-in-out;
  }
  .ob-selector__select {
    background: #000;
  }
  .multi-nav-panel {
    display: flex;
    margin-bottom: 40px;
    .nav-item {
      min-width: 77px;
      width: 77px;
      height: 52px;
      border-radius: 4px;
      display: flex;
      flex-direction: column;
      margin: 0 10px 10px 0;
      cursor: pointer;
      justify-content: center;
      background: $lavender!important;
      padding: 0 12px;
      @include font-mixin(12px, 20px, 400, $color-blue-navy-blue!important, 0.4px, uppercase);
      &.active {
        color: #fff!important;
        background: $color-blue-navy-blue!important;
        pointer-events: none;
      }
      &.ob-selector{
        min-width: 192px;
        padding: 0;
        ::v-deep .ob-selector__select {
          border: none;
          background: $lavender;
        }
        ::v-deep .ob-selector__title {
          justify-content: center;
        }
        ::v-deep .ob-selector__value {
          @include font-mixin(12px, 20px, 400, $color-blue-navy-blue, 0.4px, uppercase);
        }
        ::v-deep .ob-selector__value {
          white-space: normal;
        }
      }
    }
    .nav-tabs {
      display: flex;
      flex-grow: 2;
      flex-wrap: wrap;
      &.active{
        display: flex;
      }
    }
  }
</style>
